Coordinate Class Reference (Kig Python Scripting API)

| # Kig Python Scripting API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members

Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
Coordinate Class Reference

The Coordinate class is the basic class representing a 2D location by its x and y components. More...

`#include <coordinate.h>`

## Public Member Functions
| Coordinate (double x, double y)
| Constructor.
| Coordinate (const Coordinate &p)
| Copy Constructor.
| Coordinate ()
bool | valid () const
| Return whether this is a valid Coordinate.
double | distance (const Coordinate &p) const
| Distance to another Coordinate.
double | length () const
| Length.
double | squareLength () const
| Square length.
const Coordinate | operator- () const
| Inverse.
const Coordinate | orthogonal () const
| Orthogonal.
const Coordinate | round () const
| Round.
const Coordinate | normalize (double length=1) const
| Normalize.
Coordinate & | operator+= (const Coordinate &c)
| Add.
Coordinate & | operator-= (const Coordinate &c)
| Subtract.
Coordinate & | operator*= (double r)
| Scale.
Coordinate & | operator*= (int r)
| Scale.
Coordinate & | operator/= (double r)
| Scale.

## Static Public Member Functions
static Coordinate | invalidCoord ()
| Create an invalid Coordinate.

## Public Attributes
double | x
| X Component.
double | y
| Y Component.

## Friends
const Coordinate | operator+ (const Coordinate &a, const Coordinate &b)
| Add.
const Coordinate | operator- (const Coordinate &a, const Coordinate &b)
| Subtract.
const Coordinate | operator* (const Coordinate &a, double r)
| Scale.
const Coordinate | operator/ (const Coordinate &a, double r)
| Scale.
double | operator* (const Coordinate &a, const Coordinate &b)
| Scalar Product.
bool | operator== (const Coordinate &, const Coordinate &)
| Equal.
bool | operator!= (const Coordinate &, const Coordinate &)
| Not Equal.

## Detailed Description

The Coordinate class is the basic class representing a 2D location by its x and y components.

It has all relevant arithmetic operators properly defined, and should be straightforward to use..

## Constructor & Destructor Documentation

## ◆ Coordinate() [1/2]

Coordinate::Coordinate | ( | double | x,
|  | double | y )

Constructor.

Construct a new Coordinate, with a given x and y value.

References x, and y.

Referenced by Coordinate(), Coordinate(), distance(), invalidCoord(), normalize(), operator!=, operator*, operator*, operator*=(), operator*=(), operator+, operator+=(), operator-(), operator-, operator-=(), operator/, operator/=(), operator==, orthogonal(), and round().

## ◆ Coordinate() [2/2]

Coordinate::Coordinate | ( | const Coordinate & | p | ) |

Copy Constructor.

Construct a new Coordinate, and give it the same value as p.

References Coordinate().

## Member Function Documentation

## ◆ invalidCoord()

Coordinate Coordinate::invalidCoord | ( |  | ) |
| static

Create an invalid Coordinate.

This is a special value of a Coordinate that signals that something went wrong..

See also
  Coordinate::valid

References Coordinate().

## ◆ length()

double Coordinate::length | ( |  | ) | const

Length.

Returns the length or norm of this coordinate. I.e. return the distance from this Coordinate to the origin.

See also
  squareLength

Referenced by normalize().

## ◆ normalize()

const Coordinate Coordinate::normalize | ( | double | length = 1 | ) | const

Normalize.

This sets the length to length, while keeping the x/y ratio untouched...

References Coordinate(), and length().

## ◆ operator*=() [1/2]

Coordinate & Coordinate::operator*= | ( | double | r | ) |

Scale.

Scales this Coordinate by a factor r

References Coordinate().

## ◆ operator*=() [2/2]

Coordinate & Coordinate::operator*= | ( | int | r | ) |

Scale.

Scales this Coordinate by a factor r

References Coordinate().

## ◆ operator+=()

Coordinate & Coordinate::operator+= | ( | const Coordinate & | c | ) |

Add.

Add c to this Coordinate

References Coordinate().

## ◆ operator-()

const Coordinate Coordinate::operator- | ( |  | ) | const

Inverse.

Returns the inverse of this Coordinate.

References Coordinate().

## ◆ operator-=()

Coordinate & Coordinate::operator-= | ( | const Coordinate & | c | ) |

Subtract.

Subtract c from this Coordinate

References Coordinate().

## ◆ operator/=()

Coordinate & Coordinate::operator/= | ( | double | r | ) |

Scale.

Scales this Coordinate by a factor 1/r

References Coordinate().

## ◆ orthogonal()

const Coordinate Coordinate::orthogonal | ( |  | ) | const

Orthogonal.

Returns a vector which is orthogonal on this vector. This relation always holds:

    Coordinate a = ...;
    assert( a*a.orthogonal() ) == 0;

References Coordinate().

## ◆ round()

const Coordinate Coordinate::round | ( |  | ) | const

Round.

Returns this coordinate, rounded to the nearest integral values.

References Coordinate().

## ◆ squareLength()

double Coordinate::squareLength | ( |  | ) | const

Square length.

Equivalent to the square of length, but a bit more efficient because no square root has to be calculated.

See also
  length

References x, and y.

## ◆ valid()

bool Coordinate::valid | ( |  | ) | const

Return whether this is a valid Coordinate.

See also
  Coordinate::invalidCoord

## Friends And Related Symbol Documentation

## ◆ operator!=

bool operator!= | ( | const Coordinate & | ,
|  | const Coordinate & | )
| friend

Not Equal.

Tests two Coordinates for inequality.

References Coordinate().

## ◆ operator* [1/2]

double operator* | ( | const Coordinate & | a,
|  | const Coordinate & | b )
| friend

Scalar Product.

Returns the scalar product of a and b.

References Coordinate().

## ◆ operator* [2/2]

const Coordinate operator* | ( | const Coordinate & | a,
|  | double | r )
| friend

Scale.

Returns this a, scaled by a factor of r.

References Coordinate().

## ◆ operator+

const Coordinate operator+ | ( | const Coordinate & | a,
|  | const Coordinate & | b )
| friend

Add.

Returns the sum of a and b.

References Coordinate().

## ◆ operator-

const Coordinate operator- | ( | const Coordinate & | a,
|  | const Coordinate & | b )
| friend

Subtract.

Returns the difference between a and b.

References Coordinate().

## ◆ operator/

const Coordinate operator/ | ( | const Coordinate & | a,
|  | double | r )
| friend

Scale.

Returns a, scaled by a factor of 1/r.

References Coordinate().

## ◆ operator==

bool operator== | ( | const Coordinate & | ,
|  | const Coordinate & | )
| friend

Equal.

Tests two Coordinates for equality.

References Coordinate().

## Member Data Documentation

## ◆ x

double Coordinate::x

X Component.

The X Component of this Coordinate.

Referenced by Coordinate(), and squareLength().

## ◆ y

double Coordinate::y

Y Component.

The Y Component of this Coordinate.

Referenced by Coordinate(), and squareLength().

This file is part of the documentation for tdelibs .
Documentation copyright © 1996-2002 the KDE developers.
Generated on by doxygen 1.16.1 written by Dimitri van Heesch, © 1997-2001